var baseURL = 'http://www.shuduier.com';

//var baseURL = 'http://test59.shuduier.com';
// 服务器请求地址
var serverurl = baseURL + '/api';

// 获取server request基本请求数据
function getReqData() {
	var reqData = new Object();
	// appid
	reqData.appid = 'shuduier';
	// app端
	reqData.client = 'app';
	// 设备ID
	reqData.deviceId = api.deviceId;
	// 设备型号
	reqData.deviceModel = api.deviceModel;
	// 设备名称
	reqData.deviceName = api.deviceName;
	// 应用版本号
	reqData.version = api.appVersion;
	// 应用版本号
	reqData.versionCode = 200;
	// 系统类型
	reqData.systemType = api.systemType;
	// 手机平台的系统版本
	reqData.systemVersion = api.systemVersion;
	// 引擎版本信息
	reqData.engineVersion = api.version;
	// 设备类型
	reqData.uiMode = api.uiMode;
	// 时间戳
	reqData.nowtime = new Date().getTime();
	// 随机数
	reqData.ramdon = Math.round(Math.random() * 100000);
	// 用户token
	var user = $api.getStorage('user');
	if(user != null && user != '') {
		reqData.sdrlogin_uuuid = user.sdrlogin_uuuid;
	}
	return reqData;
}

// server request 方法
function serRequest(reqData, callback) {
	
	// 获取appsign并进行文章加密将数据发送至服务器
	api.loadSecureValue({
		key : 'appsecret'
	}, function(ret, err) {
		// 建立加密数组
		var secretArr = new Array();
		secretArr[0] = reqData.deviceid;
		secretArr[1] = reqData.nowtime;
		secretArr[2] = reqData.ramdon;
		secretArr[3] = ret.value;
		
		// 按照ASCII字符代码从小到大排序
		secretArr.sort();

		// 将加密值写入reqData对象
		reqData.secretstr = hex_md5(secretArr.join(""));
		
		var filesData = new Object();
		if(null != reqData.filename)
		{
			filesData.filename = reqData.filename;
			delete reqData.filename; 
		}
		var headersData = new Object();
		if(null != reqData.enctype)
		{
			headersData.enctype = reqData.enctype;
			delete reqData.enctype; 
		}
		
		// 获取请求路径
		var url = serverurl + reqData.path;
		// ajax 请求服务器 查看返回结果
		api.ajax({
			url : url,
			method : 'post',
			cache : false,
			timeout : 20,
			dataType : 'json',
			returnAll : false,
			headers : {"Content-Type": headersData.enctype},
			data : {
				values : reqData,
				files: filesData
			}
		}, function(ret, err) {
		
			// 只要网络请求有回应，就应该停止加载动画
			api.hideProgress();
			if (err) {
				// 0连接错误
				api.toast({
					msg : err.msg,
					location : 'middle'
				});
				api.hideProgress();
			} else {
				if (ret) {
					setTimeout(function() {
						var wrap = $api.byId("wrap");
						if(null != wrap){
							$api.attr(wrap, "id", "okwrap");
						}
					}, '500');
					if(ret.errorKey != null && ret.errorKey == 'notFindUser'){
						$api.rmStorage('user');
						api.execScript({
							name: 'personalcenteral',
			                script: 'updateUserinfo();'
		                });
						openLogin();
						return;
					}
				} 
				callback(ret);
			}

		});

	});
}

function refreshRem (designWidth) {
	var width = document.documentElement.getBoundingClientRect().width;
	var rem = width*20/designWidth;
	document.documentElement.style.fontSize = rem + "px" ;
}
// 打开登录页面
function openLogin(){
	var frameUrl = api.wgtRootDir + '/html/personalcenteral/login.html';
	api.openWin({
        name: 'login',
        url: api.wgtRootDir + '/html/second_win.html',
        pageParam: {
        	frameParam:{},
        	title: '登录',
        	frameUrl: frameUrl
        }
    });
}
// 关闭页面
function closeWin() {
	api.closeWin();
}
//延时加载图片
function delayImg() {
    var aImg = document.getElementsByClassName('delayimg');
    var len = aImg.length;

    for(var i = 0; i < len; i++) {
        var thisImg = aImg[i];
        if(thisImg.getAttribute('delayed') == 'delayimgnot') {
            if((thisImg.getBoundingClientRect().top - thisImg.offsetHeight/2) < 
                    document.documentElement.clientHeight) {
                var imgurl = thisImg.getAttribute('delayImg_data');
                if(imgurl != null && imgurl != ''){
                	var imgsrc = thisImg.setAttribute('src', imgurl);
	                if(imgsrc) {
	                	thisImg.setAttribute('delayed', 'delayed');
	                }
                }
            }
        }
    }
}
// 修改图书封面
function formatCoverimg(booklist){
	for(var i=0;i<booklist.length;i++){
		var coverimg = booklist[i].coverimg;
		if(coverimg != null && coverimg.indexOf("http") != 0){
			booklist[i].coverimg = baseURL + booklist[i].coverimg;
		}
	}
	return booklist;
}
window.onscroll = function() {
    delayImg();
};

(function(window){
	var u = {};
	
	// 获取字符实际长度
	function strLength(str){
		///<summary>获得字符串实际长度，中文2，英文1</summary>  
	    ///<param name="str">要获得长度的字符串</param>  
	    var realLength = 0, len = str.length, charCode = -1;  
	    for (var i = 0; i < len; i++) {  
	        charCode = str.charCodeAt(i);  
	        if (charCode >= 0 && charCode <= 128) realLength += 1;  
	        else realLength += 2;  
	    }  
	    return realLength;
	}
	
	// 字符串长度
	u.stringLength = function(str, min, max){
		var validator = true;
		var realLength = strLength(str);
		if(null == min && null == max){
			validator = false;
		}
		if(null != min && realLength < min){
			validator = false;
		}
		if(null != max && realLength > max){
			validator = false;
		}
		return validator;
	};
	
	// 不为空
	u.notEmpty = function(str){
		var validator = true;
		if(null == str || '' == str){
			validator = false;
		}
		return validator;
	}
	
	// 自定义正则表达式
	u.regexp = function(str,regexp){
		return regexp.test(str);
	}
	
	// 手机号
	u.phone = function(str){
		return /^((00|\+)?(86(?:-| )))?((\d{11})|(\d{3}[- ]{1}\d{4}[- ]{1}\d{4})|((\d{2,4}[- ]){1}(\d{7,8}|(\d{3,4}[- ]{1}\d{4}))([- ]{1}\d{1,4})?))$/.test(str);
	}
	
	// 身份证号
	u.idNumber=function(str){
		return /^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$|^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}([0-9]|X)$/.test(str);
	}
	// 值是否一致
	u.different = function(str, str2){
		var validator = true;
		if(!u.notEmpty(str) || !u.notEmpty(str2)){
			validator = false;
		}
		if(str != str2){
			validator = false;
		}
		return validator;
	}
	
	window.$validate = u;
})(window)